#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "dominoes"
typedef long long int64;

const int MaxN = 10;

bool a [MaxN] [MaxN];
int m, n;
int64 count;

void recur (int x, int y)
{
 if (x == m) {x = 0, y++;}
 if (y == n) {count++; return;}
 if (a[x][y]) {recur (x + 1, y); return;}
 a[x][y] = true;
 if (x + 1 < m && !a[x + 1][y])
 {a[x + 1][y] = true; recur (x + 2, y); a[x + 1][y] = false;}
 if (y + 1 < n)
 {a[x][y + 1] = true; recur (x + 1, y); a[x][y + 1] = false;}
 a[x][y] = false;
}

int main (void)
{
 freopen (TASKNAME ".in", "r", stdin);
 freopen (TASKNAME ".out", "w", stdout);
 while (scanf (" %d %d", &m, &n) != EOF)
 {
  count = 0;
  memset (a, 0, sizeof (a));
  recur (0, 0);
  printf ("%I64d\n", count);
 }
 return 0;
}
