#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>

using namespace std;

#define TASKNAME "permut"
typedef long long int64;

const int MaxN = 50;
const int64 MaxC = 1234567890123456789LL;

int a [MaxN + 1];
bool b [MaxN + 1];
int64 f [MaxN + 1];
int64 k;
int n;

int main (void)
{
 int i, n;
 int64 k, l;
 freopen (TASKNAME ".in", "r", stdin);
 freopen (TASKNAME ".out", "w", stdout);
 l = 1;
 f[0] = l;
 f[1] = l;
 for (i = 2; i <= MaxN; i++)
 {
  if (MaxC / l < i) l = MaxC;
  else l *= i;
  f[i] = l;
 }
 while (scanf (" %d %I64d", &n, &k) != EOF)
 {
  if (k <= 0) {printf ("Invalid number!\n"); continue;}
  for (i = 0; i < n; i++) a[i] = i + 1;
  k--;
  for (l = 0; l < k; l++)
   if (!next_permutation (a, a + n))
    break;
  if (l < k)
   printf ("Invalid number!\n");
  else
  {
   for (i = 0; i < n; i++)
    printf ("%d%c", a[i], (i < n - 1) ? ' ' : '\n');
  }
 }
 return 0;
}
