#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "dominoes"
typedef long long int64;

const int MaxN = 10, MaxK = 1 << MaxN;

int64 f [2] [MaxK];
int k, m, n;

int main (void)
{
 int b, i, j, l;
 freopen (TASKNAME ".in", "r", stdin);
 freopen (TASKNAME ".out", "w", stdout);
 while (scanf (" %d %d", &m, &n) != EOF)
 {
  k = 1 << m;
  b = 0;
  memset (f[b], 0, sizeof (f[b]));
  f[b][0] = 1;
  for (i = 0; i < n; i++)
   for (j = 0; j < m; j++)
   {
    b = !b;
    memset (f[b], 0, sizeof (f[b]));
    for (l = 0; l < k; l++)
    if (f[!b][l])
    {
     f[b][l ^ (1 << j)] += f[!b][l];
     if (j + 1 < m && !(l & (3 << j)))
      f[b][l | (2 << j)] += f[!b][l];
    }
   }
  printf ("%I64d\n", f[b][0]);
 }
 return 0;
}
