#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "permut"
typedef long long int64;

const int MaxN = 50;
const int64 MaxC = 1234567890123456789LL;

int a [MaxN + 1];
bool b [MaxN + 1];
int64 f [MaxN + 1];
int64 k;
int n;

int main (void)
{
 int i, j, m, n;
 int64 k, l;
 freopen (TASKNAME ".in", "r", stdin);
 freopen (TASKNAME ".out", "w", stdout);
 l = 1;
 f[0] = l;
 f[1] = l;
 for (i = 2; i <= MaxN; i++)
 {
  if (MaxC / l < i) l = MaxC;
  else l *= i;
  f[i] = l;
 }
 while (scanf (" %d %I64d", &n, &k) != EOF)
 {
  if (k <= 0 || k > f[n]) {printf ("Invalid number!\n"); continue;}
  k--;
  memset (b, 0, sizeof (b));
  for (i = n; i >= 1; i--)
  {
   j = 1;
   while (k >= f[i - 1]) {j++, k -= f[i - 1];}
   m = 0;
   for ( ; j > 0; j--)
    do {m++;} while (b[m]);
   a[i] = m;
   b[m] = true;
  }
  for (i = n; i >= 1; i--)
  for (i = n; i >= 1; i--)
   printf ("%d%c", a[i], (i > 1) ? ' ' : '\n');
 }
 return 0;
}
