#include <stdio.h>
#include <string.h>

#define MaxM 10

int m, n;
__int64 f[MaxM + 1][1 << MaxM];

void find(int isrc, int msrc, int idst,
		int mdst, int step) {
	if (step >= n) {
		f[idst][mdst] += f[isrc][msrc];
		return;
	}
	if (msrc & (1 << step))
		find(isrc, msrc, idst, mdst,
			step + 1);
	else {
		if (!(mdst & (1 << step)))
			find(isrc, msrc,
				idst, mdst | (1 << step), step + 1);
		if (!(msrc & (1 << (step + 1))) && step + 1 < n)
			find(isrc, msrc, idst, mdst, step + 2);
	}
}

int main(void) {
	int i, j, msrc, mdst;
	freopen("dominoes.in", "rt", stdin);
	freopen("dominoes.out", "wt", stdout);
	scanf("%d%d", &m, &n);
	memset(f, 0, sizeof(f));
	f[0][0] = 1;
	for (j = 0; j < m; j++)
		for (msrc = 0; msrc < (1 << n); msrc++)
			find(j, msrc, j + 1, 0, 0);
	printf("%d\n", f[m][0]);
	return 0;

}
